// Generated by N4JS transpiler; for copyright see original N4JS source file.

import 'n4js-runtime'
import {ResultGroup} from './ResultGroup.js'
import {aggregateTestStatuses} from './TestStatus.js'

export class ResultGroups extends N4Object {
	constructor(results) {
		super();
		this.results = undefined;
		this.successes = 0;
		this.failures = 0;
		this.skipped = 0;
		this.errors = 0;
		this.results = results;
		this.accumulateResults(results);
	}
	aggregate() {
		let result;
		let trMap = new Map();
		let description;
		for(let rg of this.results) {
			description = rg.description;
			for(let tr of rg.testResults) {
				if (trMap.has(tr.description)) {
					let oldTr = trMap.get(tr.description);
					let testStatus = aggregateTestStatuses(tr.testStatus, oldTr.testStatus);
					if (testStatus != oldTr.testStatus) {
						trMap.set(tr.description, tr);
					}
				} else {
					trMap.set(tr.description, tr);
				}
			}
		}
		result = new ResultGroup(Array.from(trMap.values()), description);
		return result;
	}
	accumulateResults(results) {
		for(let result of results) {
			this.successes += result.successes;
			this.failures += result.failures;
			this.errors += result.errors;
			this.skipped += result.skipped;
		}
	}
	static concat(...resultGroups) {
		return this.concatArray(resultGroups);
	}
	static concatArray(resultGroupss) {
		const newResultGroups = new ResultGroups([]);
		for(let resultGroup of resultGroupss) {
			newResultGroups.successes += resultGroup.successes;
			newResultGroups.failures += resultGroup.failures;
			newResultGroups.errors += resultGroup.errors;
			newResultGroups.skipped += resultGroup.skipped;
			newResultGroups.results = newResultGroups.results.concat(resultGroup.results);
		}
		return newResultGroups;
	}
	static get n4type() {
		return $getReflectionForClass(this, '["ResultGroups","org/eclipse/n4js/mangelhaft/types/ResultGroups","org.eclipse.n4js.mangelhaft",["f.results","f.successes","f.failures","f.skipped","f.errors"]]');
	}
}
//# sourceMappingURL=ResultGroups.map
